#ifndef KSIM_CPU_SOLARIS_H
#define KSIM_CPU_SOLARIS_H

#include <kstat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include <sys/sysinfo.h>
#include <errno.h>

typedef uint32_t CPUInstance;
typedef uint64_t CPUId;

typedef struct CPUInfo
{
  CPUId id;
  CPUInstance instance;
  uint32_t clockMHz;
  uint32_t online;
  char name[32];
  char cpuType[32];
  char fpuType[32];
  char implementation[64];
  char state[16];
} CPUInfo;

typedef struct CPUIndex
{
  uint32_t id;
  uint32_t index;
} CPUIndex;

void initCpuInfo();
int updateCpuInfo();
double getCpuIdle(int cpuId);
double getCpuUser(int cpuId);
double getCpuKernel(int cpuId);
double getCpuWait(int cpuId);
const char* getCpuName(int cpuId);

#endif
