#ifndef KSIM_NET_SOLARIS_H
#define KSIM_NET_SOLARIS_H

#include <string>
#include <vector>
using namespace std;

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stropts.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/sockio.h>
#include <net/if.h>

class NetDevInfo
{
public:
	NetDevInfo();
	NetDevInfo(const NetDevInfo& rhs);
	~NetDevInfo();
	NetDevInfo& operator= (const NetDevInfo& rhs);

	std::string     Name;
        short           flags;
        unsigned long   ipackets;
        unsigned long   OLDipackets;
        unsigned long   opackets;
        unsigned long   OLDopackets;
        unsigned long   ierrors;
        unsigned long   OLDierrors;
        unsigned long   oerrors;
        unsigned long   OLDoerrors;
        unsigned long   collisions;
        unsigned long   OLDcollisions;
        unsigned long   multixmt;
        unsigned long   OLDmultixmt;
        unsigned long   multircv;
        unsigned long   OLDmultircv;
        unsigned long   brdcstxmt;
        unsigned long   OLDbrdcstxmt;
        unsigned long   brdcstrcv;
        unsigned long   OLDbrdcstrcv;
};

typedef std::vector<NetDevInfo> NetDevInfoVector;

#define NBUFFERS 64
#define MAXNETDEVS 64

int insertnetdev (const char *name, short flags);
int getnetdevlist();
int getndetdevcount();
int updatenetdev();
const NetDevInfoVector& getnetdevvector();

#endif

